﻿/* Distributer + SureTarget + 3D Falloff
	by: Nathan Gambles
	January 30, 2009
	
	OS: Windows and OSX - hopefully.  
	
	I cannot check the functionality of an OSX system or older versions of AE before CS4.  So I hope it works for everyone.
	
	Distributer sets up several 3D Layers that are all controlled by the Distributer Null to arrange them in 3D Space.  It also sets up AndrewKramers
	presets SureTarget and 3D Falloff automatically, each with Control Nulls as well.  All contols can be found on the null layers and the 3D layers themselves can
	be individually dragged around and scaled.  Great for setting up a scene then replacing the distributed solids with your design
	elements using the Alt + replacement method.  Adjust the anchor point of layers to arrange them to your liking as well as adjust your
	camera position.  
*/
{
var nullNames = [ "SureTarget", 1 , "Falloff", 0 ];  // Null names and is 3D boolean
var nameSolid = "Distributed Layer 01";

var userDefinedPresetPath = false;
var userPresetPath = "/Programme/Adobe/Adobe After Effects CS4/Support Files/Presets/__-Video Copilot-__/";    //enter the location of your presets starting with a "/" and excluding any c:/ and such.

{/******************  Distributer SetUp *************************************/
var setUpDistributer = true;

var distribXYZ = [550 , 215 , 1600 ];
var rotXYZ = [ 0 , 145 , 0 ];
var scaler = 100;
var rotSpeed = [ 5 , 0 , 0 ];

/****************************************************************************/

var posExpression = 'theSeed = thisComp.layer("Distributer").effect("Seed")("Slider");\r mySeed = (theSeed + index)*1000; seedRandom(mySeed);\r x = wiggle( 0 , thisComp.layer("Distributer").effect("Distribute X, Y")("Point")[0])[0]; \r  y = wiggle( 0 , thisComp.layer("Distributer").effect("Distribute X, Y")("Point")[1])[1]; \r z = wiggle( 0 , thisComp.layer("Distributer").effect("Distribute Z")("Slider"))[2]; \r [x,y,z] ';
var xRotExpression = 'theSeed = thisComp.layer("Distributer").effect("Seed")("Slider");\r mySeed = (theSeed + index)*1000; seedRandom(mySeed);\rwig = wiggle ( 0 , thisComp.layer("Distributer").effect("X Rotation")("Angle")); \r RotSpeed = thisComp.layer("Distributer").effect("X Rotation Speed")("Slider"); \r wig + time * RotSpeed ';
var yRotExpression = 'theSeed = thisComp.layer("Distributer").effect("Seed")("Slider");\r mySeed = (theSeed + index)*1000; seedRandom(mySeed);\rwig = wiggle ( 0 , thisComp.layer("Distributer").effect("Y Rotation")("Angle")); \r RotSpeed = thisComp.layer("Distributer").effect("Y Rotation Speed")("Slider"); \r wig + time * RotSpeed ';
var zRotExpression = 'theSeed = thisComp.layer("Distributer").effect("Seed")("Slider");\r mySeed = (theSeed + index)*1000; seedRandom(mySeed);\rwig = wiggle ( 0 , thisComp.layer("Distributer").effect("Z Rotation")("Angle")); \r RotSpeed = thisComp.layer("Distributer").effect("Z Rotation Speed")("Slider"); \r wig + time * RotSpeed ';
var scaleExpression = 'scaler = thisComp.layer("Distributer").effect("scale")("Slider");\r value * scaler / 100 ';
/******************************************************************************/}

/*****************************************************************************/
{/******************  SureTarget SetUp *************************************/
var setUpSureTarget = true;

var theTargeter = [ 5 , 1 , 1/24*3, .5 ] ;    // [ number of targets to set , time between , start time, wait time
var easeTarget = true;
var autoRotate = true;
var wiggleAmount = 0 ;
var wiggleSpeed = 0 ;
}

{/******************  3D Falloff SetUp *************************************/
var setUpFalloff = true;

var useColor = true;
var colorFalloff = [ .14 , .414 , .035 ];
var colorTint = 100;
var cFalloffStart = 825;
var cFalloffEnd = 2000;
var useFade = true;
var fadeMin = 0;
var fadeMax = 100;
var fFalloffStart = 825;
var fFalloffEnd = 2000;

/**************************************************************************/}
/******************************************************************************/
{/**********************Global Variables***************************************/
var proj;
var myComp;
var loadDistributer;
var loadSureTarget;
var loadFalloff;
var preCount;
var numSolids ;
var distributer;
var myPalette;
var mySolid;
var distXY;
var distZ;
var Xrot;
var Yrot;
var Zrot;
var distScaler;
var XrotSpeed;
var YrotSpeed;
var ZrotSpeed ;
var numSolids;
var osPath;
var versionPath;
var VCPPresetPath = "Presets/__-Video Copilot-__/";
var infoMessage = "Create a new comp with desired settings.\rSelect desired Presets from list.\rClick 'Apply Selected Setups'.'";
}

function setUpNull(){
	if(loadDistributer == true){
		distributer = myComp.layers.addNull();
		distributer.name = "Distributer";
		distributer.enabled = false;
	
		distXY = distributer("Effects").addProperty("Point Control");
		distXY.name = "Distribute X, Y";
		distZ = distributer("Effects").addProperty("Slider Control");
		distZ.name = "Distribute Z";
		Xrot = distributer("Effects").addProperty("Angle Control");
		Xrot.name = "X Rotation";
		Yrot = distributer("Effects").addProperty("Angle Control");
		Yrot.name = "Y Rotation";
		Zrot = distributer("Effects").addProperty("Angle Control");
		Zrot.name = "Z Rotation";
		distScaler = distributer("Effects").addProperty("Slider Control");
		distScaler.name = "scale";
		XrotSpeed = distributer("Effects").addProperty("Slider Control");
		XrotSpeed.name = "X Rotation Speed";
		YrotSpeed = distributer("Effects").addProperty("Slider Control");
		YrotSpeed.name = "Y Rotation Speed";
		ZrotSpeed = distributer("Effects").addProperty("Slider Control");
		ZrotSpeed.name = "Z Rotation Speed";
		distSeed = distributer("Effects").addProperty("Slider Control");
		distSeed.name = "Seed";
	 
		var dist = myComp.layer("Distributer");
	
		dist.effect("Distribute X, Y")("Point").setValue([ distribXYZ[0] , distribXYZ[1] ]);
		dist.effect("Distribute Z")("Slider").setValue( distribXYZ[2] );
		dist.effect("X Rotation")("Angle").setValue( rotXYZ[0] );
		dist.effect("Y Rotation")("Angle").setValue( rotXYZ[1] );
		dist.effect("Z Rotation")("Angle").setValue( rotXYZ[2] );
		dist.effect("scale")("Slider").setValue( scaler);
		dist.effect("X Rotation Speed")("Slider").setValue( rotSpeed[0] );
		dist.effect("Y Rotation Speed")("Slider").setValue( rotSpeed[1] );
		dist.effect("Z Rotation Speed")("Slider").setValue( rotSpeed[2] );
		dist.effect("Seed")("Slider").setValue( 0 );
		
	 }
	 
}
function setUpSolid(){
	mySolid = myComp.layers.addSolid( [.1 , .2 , .8] , nameSolid , 75 , 135 , myComp.pixelAspect);
	mySolid.threeDLayer = true;
	
	if(loadDistributer == true){
		mySolid.property("position").expression = posExpression;
		mySolid.property("xRotation").expression = xRotExpression;
		mySolid.property("yRotation").expression = yRotExpression;
		mySolid.property("zRotation").expression = zRotExpression;
		mySolid.property("scale").expression = scaleExpression;
		mySolid.moveAfter(myComp.layer("Distributer"));
	}
	mySolid.motionBlur = true;
	
	setPresets(mySolid.name)
}
function makeCam(){

	var myCam = myComp.layers.addCamera("Camera 1" , [ 0 , 0 ]);
	myCam.property("position").setValue( [0,0,-700]);
	myCam.moveToBeginning();
	myCam.setParentWithJump(myComp.layer(nullNames[0]));
	myCam.startTime = 0;
	
	myComp.motionBlur = false;
}
function checkVersion(){
	var versionCheck = Number(String(app.version).split(".")[0]);
	versionPath = "/whoKnows??";											// Enter a userDefined Path to your Presets folder and set UserDefined Path to True.  

	if( userDefinedPresetPath == false){
		switch( versionCheck ){
			case 7:
				versionPath = "Adobe After Effects 7.0/Support Files/";
				break;
			case 8:
				versionPath = "Adobe After Effects CS3/Support Files/";
				break;
			case 9:
				versionPath = "Adobe After Effects CS4/Support Files/";
				break;
			default:
				alert("Cannot find determine your AE version #.  Please put in the system default location\ror change the versionPath variable in the checkVersion() function of the script");
				break;
		}
	}

	try{
		var OpSystem = system.osName.split(" ")[1].toLowerCase();
	}catch(err){
		OpSystem = "mac";
	}

	if(OpSystem == "windows"){
			osPath ="/Program Files/Adobe/";
	}else{
			osPath ="/Applications/";
	}
}

function setPresets(theName){

try{
	if( userDefinedPresetPath == false){
		var surePath = escape(String(osPath+ versionPath + VCPPresetPath + "SureTarget/SureTarget 1.5.1.ffx"));// full path to SureTarget Preset	
		var fallLayersPath = escape(String(osPath+ versionPath + VCPPresetPath + "3D Falloff/3DFalloff_3D-Layers_1.1.ffx"));// full path to Falloff Preset for Layers
		var fallNullPath = escape(String(osPath+ versionPath + VCPPresetPath + "3D Falloff/3DFalloff_Control_Rename_Falloff_1.1.ffx"));// full path to Falloff Preset for Null	
	}else if( userDefinedPresetPath == true){
		var surePath = escape(String(userPresetPath + "SureTarget/SureTarget 1.5.1.ffx"));// full path to SureTarget Preset	
		var fallLayersPath = escape(String(userPresetPath + "3D Falloff/3DFalloff_3D-Layers_1.1.ffx"));// full path to Falloff Preset for Layers
		var fallNullPath = escape(String(userPresetPath + "3D Falloff/3DFalloff_Control_Rename_Falloff_1.1.ffx"));// full path to Falloff Preset for Null
	}
	var fLayerPreset = File(fallLayersPath);
	var fNullPreset = File(fallNullPath);
	var surePreset = File(surePath);
	
	switch (theName){
			case nullNames[0]:
				if(loadSureTarget == true){
					myComp.layer(nullNames[0]).applyPreset(surePreset);
				}
				break;
			
			case nullNames[2]:
				if(loadFalloff == true){
					myComp.layer(nullNames[2]).applyPreset(fNullPreset);
				}
				break;

			case nameSolid:
				if(loadFalloff == true){
					myComp.layer(nameSolid).applyPreset(fLayerPreset);
				}
				break;
			
			default:
				alert("You got a problem");
				break;
	}

}catch(err){
		alert("Cannot Find The VideoCopilot Presets.\r\rPlease put them in the default After Effects Presets Folder and in the __-Video Copilot-__ Folder.\rOr Modify the 'userDefinedPresetPath = true'  and set 'userPresetPath = '  found at the top of the script to set the preset location manually.");
}
}
function createVCPNulls(){
	
	for(var i=0; i < nullNames.length ; i = i + 2){
		var currentNull = nullNames[i];
		currentNull = myComp.layers.addNull();
		currentNull.name = nullNames[i];
		currentNull.enabled = false;
		if(nullNames[i+1] ==1){
				currentNull.threeDLayer = true;
		}
		setPresets(nullNames[i]);
	}
	if(loadSureTarget == false){
			myComp.layer("SureTarget").remove();
	}
	if(loadFalloff == false){
			myComp.layer("Falloff").remove();
	}
}

function duplicator(){

	var target;
	var prMessage = "How many 3D layers do you want?";
	numSolids = 1;
	
	target = myComp.layer(nameSolid);
	numSolids = prompt(prMessage, numSolids, "Duplicator");
	for(var i = 1 ; i < numSolids ; i++){		
			target.duplicate().moveAfter(myComp.layer( (target.index + i - 1 )));
	}		
}
function arrange(){
	
	try{myComp.layer("Camera 1").moveToBeginning();}catch(err){}
	try{myComp.layer("SureTarget").moveToBeginning();}catch(err){}
	try{myComp.layer("Falloff").moveToBeginning();}catch(err){}
	try{myComp.layer("Distributer").moveToBeginning();}catch(err){}
	
}
function setFalloff(){
	
		if(setUpFalloff == true && loadFalloff == true){
		
			var fall = myComp.layer("Falloff");
		
			fall.effect("Use_Color________")("Checkbox").setValue( useColor );
			fall.effect("Color_Falloff")("Color").setValue( colorFalloff );
			fall.effect("Color_Tint")("Slider").setValue( colorTint);
			fall.effect("Color_Start_FallOff")("Slider").setValue ( cFalloffStart);
			fall.effect("Color_End_FallOff")("Slider").setValue ( cFalloffEnd);
			fall.effect("Use_Fade________")("Checkbox").setValue( useFade);
			fall.effect("Fade_Min")("Slider").setValue ( fadeMin);
			fall.effect("Fade_Max")("Slider").setValue ( fadeMax);
			fall.effect("Opac_Start_FallOff")("Slider").setValue ( fFalloffStart );
			fall.effect("Opac_End_FallOff")("Slider").setValue ( fFalloffEnd );
		}
}
function setSureTarget(){
	if(setUpSureTarget == true && loadSureTarget == true){
		var sureT = myComp.layer("SureTarget");
		var sTime = theTargeter[2];
		var transTime = theTargeter[1];
		var waitTime = theTargeter[3];
	
		sureT.effect("EaseTargets")("Checkbox").setValue (easeTarget );
		sureT.effect("AutoRotate")("Checkbox").setValue ( autoRotate );
		sureT.effect("WiggleAmount")("Slider").setValue ( wiggleAmount );
		sureT.effect("WiggleSpeed")("Slider").setValue ( wiggleSpeed );
		
		for (var i = 0 ; i < Math.min(numSolids, theTargeter[0]) ; i++){
			sureT.effect("T-"+(i+1))("Layer").setValue ( i + perCount );
		}

	var time1 = sTime;
	var time2 = sTime + transTime;
	var time3 = sTime + transTime + waitTime;
	var time4 = sTime + transTime * 2 + waitTime;
	var time5 = sTime+(transTime + waitTime) * 2;
	var time6 = sTime+transTime*3 + waitTime * 2;
	var time7 = sTime+(transTime + waitTime) *3;
	var time8 = sTime+transTime*4 + waitTime * 3;

	sureT.effect("SureTarget")("Slider").setValuesAtTimes ( [time1, time2, time3, time4, time5, time6, time7, time8] , [1,2,2,3,3,4,4,5 ] );
	}
}
function applySetups(){

	init();
	
	app.beginUndoGroup("Distribute_SureTarget_Falloff");
	
	loadDistributer = myPalette.grp.distGroup.setup.value;
	loadSureTarget = myPalette.grp.stGroup.setup.value;
	loadFalloff = myPalette.grp.fallGroup.setup.value;
	
	perCount = 5;
	if(loadDistributer == false){
			perCount --;
	}
	if(loadSureTarget == false){
			perCount --;
	}
	if(loadFalloff == false){
			perCount --;
	}
	
		setUpNull();
		createVCPNulls();
		setUpSolid();
		makeCam();
		duplicator();
		setFalloff();
		setSureTarget();
		arrange();
		
	app.endUndoGroup();
}
function createUI (thisObj) {

	var showClearSelected = false;
	var textSize = [0, 0, 40, 15];

	myPalette = (thisObj instanceof Panel) ? thisObj : new Window("myPalette", "Presets Setup", undefined, {resizeable: true});
	myPalette.margins = 10;
	myPalette.alignChildren = 'left';

	// apply button
	{ // {{{

		var buttonGrp = myPalette.add('group', undefined, 'Button group');
		//buttonGrp.add('statictext', textSize, '');

		// standard buttons
		if (showClearSelected)
		{
			var clearSetupsBtn     = buttonGrp.add('button', undefined, 'Clear Selected Setups');
			clearSetupsBtn.onClick = clearSetups;
		}

		////////////////////	
		// apply button
		////////////////////	

		var applyBtn     = buttonGrp.add('button', undefined, 'Apply Selected Setups');
		applyBtn.onClick = applySetups;
		
		var howBtn = buttonGrp.add('button', undefined, 'How to Use');
		howBtn.onClick = info;

	} // }}}


	{ var res = 
				"group { \
					orientation:'column', alignment:['fill','fill'],  spacing:5, margins:[0,0,0,0], \
					stGroup: Group { \
						alignment:['left','top'], alignChildren:['left','center'], \
						grpText: StaticText { text:'" + "SureTarget 1.5.1" + "' }, \
						grpTextspacer: StaticText { text:'" + " ______ " + "' }, \
						setup: Checkbox { text:'" + "Set It Up"  + "', preferredSize: [160,20]}, \
					},\
					fallGroup: Group { \
						alignment:['left','top'], alignChildren:['left','center'], \
						grpText: StaticText { text:'" + "3D Falloff 1.1" + "' }, \
						grpTextspacer: StaticText { text:'" + " _________ " + "' }, \
						setup: Checkbox { text:'" + "Set It Up"  + "', preferredSize: [160,20]}, \
					},\
					distGroup: Group { \
						alignment:['left','top'], alignChildren:['left','center'], \
						grpText: StaticText { text:'" + "Distributer 1.0" + "' }, \
						grpTextspacer: StaticText { text:'" + " ________ " + "' }, \
						setup: Checkbox { text:'" + "Set it Up"  + "', preferredSize: [160,20]}, \
					},\
				}";				
	}	
	
	myPalette.grp = myPalette.add(res);
	
	myPalette.grp.stGroup.setup.value = true;
	myPalette.grp.fallGroup.setup.value = true;
	myPalette.grp.distGroup.setup.value = true;

	if (myPalette instanceof Window)
	{
		myPalette.show();
	}
	else
	{
		myPalette.layout.layout(true);
	}
}
function info(){
		alert(infoMessage, "How To Use");
}
function init(){

	proj = app.project;
	var compFound = 0;
	var compTest;
	if(proj == null){
		alert("Please create a project with a composition in it.");
		return false;
	}
	if (proj.activeItem instanceof CompItem){
		myComp = proj.activeItem;
		compFound = 1;
	}else{
		for (var i = 0 ; i <= proj.numItems ; i ++){
			compTest = proj.item(i + 1);
			if(compTest instanceof CompItem){
				myComp = compTest;
				compFound = 1;	
				break;
			}
		}
	}
	if(compFound == 0 ) {
		alert("No Compositions found in the project.");
		return false;
	}
		checkVersion();
		return true;
}


createUI(this);

}